!! Purpose: Fortran Course 3b 
!!          Exercise 3b-1: Usage of different IEEE arithmetics

Program exercise3b_1
   !!
   use, intrinsic :: ieee_arithmetic
   !!
   implicit none
   !!
   !! Declaration of variable 
   type (ieee_round_type)          :: default_rounding ! to backup default
   integer, parameter              :: n = 10000
   integer                         :: i, ierr
   real, dimension(:), allocatable :: a, b
   !!
   !! Allocation of a and b
   allocate(a(n), b(n), STAT = ierr)
   if (ierr > 0) stop 'Allocation failed'

   !! Initialiation of arrays a and b
   do i=1,n
     a(i) = 1.0000001
     b(i) = 2.0000009
   enddo

   !! Generate DOT product
   write(*,'(A12,A, F12.6)') 'Normal', ' based dot product: ', dot(a,b,n)

   !! Backup rounding mode
   call ieee_get_rounding_mode(round_value=default_rounding)
   write(*,*) 'Default rounding type:', default_rounding

   !! Set new rounding mode, i.e. ieee_nearest
   call ieee_set_rounding_mode(round_value=ieee_nearest)
   write(*,'(A12, A, F12.6)') 'IEEE nearest', ' based dot product: ', dot(a,b,n)

   !! Set new rounding mode, e.g. ieee_up
   call ieee_set_rounding_mode(round_value=ieee_up)
   write(*,'(A12, A, F12.6)') 'IEEE up', ' based dot product: ', dot(a,b,n)
   !! Set new rounding mode, e.g. ieee_down
   call ieee_set_rounding_mode(round_value=ieee_down)
   write(*,'(A12, A, F12.6)') 'IEEE down', ' based dot product: ', dot(a,b,n)


   !! Recover old rounding mode
   call ieee_set_rounding_mode(round_value=default_rounding)
   print '(a, f12.6)', 'Normal dot product: ', dot(a,b,n)

   contains

   real function dot(a, b, n)
      integer, intent(in) :: n
      real, dimension(:), intent(in) :: a, b
    
      real ::  s

      do i=1,n
        s = s + a(i)*b(i)
      enddo

      dot = s

   end function dot
   
end program exercise3b_1
