PROGRAM bm114                                                             

use types_modul
use, intrinsic :: iso_c_binding

implicit none

interface 
  subroutine seconds(cpu, wall) bind(c)
    use, intrinsic :: iso_c_binding
    real(kind=c_double) :: wall, cpu
  end subroutine seconds
end interface

integer ::  count, i, kk, n

real (KIND = wp) ::  s, x1(nmax), x2(nmax), x3(nmax) 
real (KIND = wp) ::  flops, stest, scomp, tim1, tim2, timd, time, tdum

!*******************************************************                   
! DIMENSION OF VECTOR (n) = 10 000 000 
!*******************************************************                   

n = nmax

s = two
do i=1,n    
  x1(i) = 2.d0
  x2(i) = DBLE(i)
enddo

write(*,'(1X,A)') '  ****** Linked Triad ****** '

call SECONDS(tim1,tdum)
print * ,' tim1, tdum= ', tim1, tdum
call DUMMY(x1,x2,x3,n)
call SECONDS(tim2,tdum)

!***  Loop over all single measurements

print * ,' HUGE(repdum): ', HUGE(repdum)
do kk=1,nloop

! repdum = MAX(1,billions/(10*n))
  repdum = 1000
  print * ,'repdum= ', repdum
  do
    call SECONDS(tim1,tdum)
    print * ,'After SECONDS '
    do j=1,repdum         
      call DUMMY(x1,x2,x3,n)    
    enddo  
    print * ,'Before SECONDS 2 '
    call SECONDS(tim2,tdum)
    print * ,'After SECONDS 2 '
    timd = tim2 - tim1
    print * ,' timdi, bound, repdum= ', timd, lowthresd, repdum
    if (timd > lowthresd) then
      exit
    else
!     if (timd <= eps) then
        repdum = repdum*10
!     else
!       repdum = INT(DBLE(repdum) * two*(lowthresd/timd))
!     endif
    endif
  enddo
! print * ,' Hallo'

  repfactor = MAX(1,millions/n)
  count = 1
  do
    call SECONDS(tim1,tdum)
    do j=1,repfactor    
      call DUMMY(x1,x2,x3,n)
      do i=1,n
        x3(i) = x1(i) + s*x2(i)  
      enddo
    enddo
    call SECONDS(tim2,tdum)
!   print * ,' tim1, tim2= ', tim1, tim2
    time = tim2 - tim1 - timd * (DBLE(repfactor)/DBLE(repdum))
!   print * ,' time= ', time

    if (time > lowthres) then
      if (time < highthres) then
        repfactornew = 0
        exit
      else
        repfactor = repfactor/cfac
      endif
    else
      if (time <= eps) then
	if (time <= zero) then
          if (count == 1) repfactor = repfactor*cfac
!         if (count >= 3)  then
          if (count >= 2)  then
            repfactornew = -1
            exit
          endif
          count = count + 1
        else
	  repfactor = repfactor*cfac
        endif
      else
	repfactornew = INT(DBLE(repfactor) * two*(lowthres/time))
        if (repfactornew > repfactor*cfac) then
          repfactor = repfactor*cfac
        else
          repfactor = repfactornew
        endif
      endif
    endif
  enddo

  if (repfactornew == 0) then
    flops = DBLE(repfactor)*DBLE(n)*2.d-6/time
    stest = 0.d0
    do i=1,n
      stest = stest + x3(i)
    enddo
    scomp = DBLE(n)*(2.d0 + DBLE(n+1))
    stest = DABS(stest - scomp)
    if (stest/scomp > eps) then
      write(*,'(1X,A)') '  WRONG RESULTS (opt. level is probably too high'
      stop
    endif
    write(*,'(1X,A,i8,A,i9,A,f9.3,A,f9.1)') '  n = ',n,'  rep_count= ',&
          repfactor,'  cpu_time= ',time,'  mflops= ',flops
  endif
  n = n/10
enddo

end program bm114
